from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Directory, Boolean, Float, Int, String

Top_Em_Equi_3_Step_Prod_Py_V0_1_0 = CommandToolBuilder(tool="top_em_equi_3_step_prod.py", base_command=["top_em_equi_3_step_prod.py"], inputs=[ToolInput(tag="in_input_pdb_file", input_type=File(optional=True), prefix="-f", doc=InputDocumentation(doc="Input PDB file")), ToolInput(tag="in_output_directory", input_type=Directory(optional=True), prefix="-o", doc=InputDocumentation(doc="Output Directory")), ToolInput(tag="in_v_site", input_type=Boolean(optional=True), prefix="-vsite", doc=InputDocumentation(doc="Use virtual site for hydrogens")), ToolInput(tag="in_ion_concentration_mm", input_type=Float(optional=True), prefix="-C", doc=InputDocumentation(doc="Ion concentration (mM), default = 0.15 (150mM)")), ToolInput(tag="in_m_steps", input_type=Int(optional=True), prefix="-m_steps", doc=InputDocumentation(doc="Minimisation nsteps, default=1000")), ToolInput(tag="in_ha_time", input_type=String(optional=True), prefix="-HA_time", doc=InputDocumentation(doc="Equilibration with HA constraint time(ns), default =")), ToolInput(tag="in_dt_ha", input_type=Float(optional=True), prefix="-dt_HA", doc=InputDocumentation(doc="Equi HA dt, default=0.005 (5 fs)")), ToolInput(tag="in_dt", input_type=Float(optional=True), prefix="-dt", doc=InputDocumentation(doc="Equi CA, CA_LOW, dt, default=0.005 (5 fs)")), ToolInput(tag="in_nt", input_type=Int(optional=True), prefix="-nt", doc=InputDocumentation(doc="Total number of threads to start, default=0")), ToolInput(tag="in_nt_mpi", input_type=Int(optional=True), prefix="-ntmpi", doc=InputDocumentation(doc="Number of thread-MPI threads to start, default=0")), ToolInput(tag="in_gpu_id", input_type=String(optional=True), prefix="-gpu_id", doc=InputDocumentation(doc="List of GPU device id-s to use, default=''")), ToolInput(tag="in_zero_dot_two_five_ns", input_type=Float(), position=0, doc=InputDocumentation(doc="-CA_time CA_TIME      Equilibration with HA constraint time(ns), default =")), ToolInput(tag="in_one_ns", input_type=Int(), position=1, doc=InputDocumentation(doc="-CA_LOW_time CA_LOW_TIME")), ToolInput(tag="in_five_ns", input_type=Int(), position=0, doc=InputDocumentation(doc="-prod_time PROD_TIME  Production time, default=10"))], outputs=[ToolOutput(tag="out_output_directory", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_output_directory", type_hint=File()), doc=OutputDocumentation(doc="Output Directory"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Top_Em_Equi_3_Step_Prod_Py_V0_1_0().translate("wdl", allow_empty_container=True)

